﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Foundation;
using UIKit;
using Telerik.XamarinForms.InputRenderer.iOS;
using TelerikUI;
using Xamarin.Forms.Platform.iOS;
using Telerik.XamarinForms.Input;
using iOSCalendarStroke.iOS.CustomRenderer;
using CoreGraphics;

[assembly: Xamarin.Forms.ExportRenderer(typeof(Telerik.XamarinForms.Input.RadCalendar), typeof(CustomStrokeCalendar))]
namespace iOSCalendarStroke.iOS.CustomRenderer
{
    class CustomStrokeCalendar : CalendarRenderer
    {
        protected override void OnElementChanged(ElementChangedEventArgs<RadCalendar> e)
        {
            base.OnElementChanged(e);
            this.Control.Delegate = new CalendarDelegate();
        }
    }

    class CalendarDelegate : TKCalendarDelegate
    {
        public override TKCalendarCell ViewForCellOfKind(TKCalendar calendar, TKCalendarCellType cellType)
        {
            if (cellType == TKCalendarCellType.Day)
            {
                return new CustomCell();
            }
            return null;
        }
    }

    public class CustomCell : TKCalendarDayCell
    {
        static UIImage gDayImage;
        static UIImage gSelectedDayImage;
        static UIImage gCurrentDayImage;

        public UIImage CurrentImage
        {
            get;
            set;
        }
        public CustomCell()
        {
            this.Initialize();
        }
        public override void UpdateVisuals()
        {
            base.UpdateVisuals();

            this.Style.BackgroundColor = UIColor.Clear;
            this.Style.Shape = null;
            this.Style.TopBorderColor = null;
            this.Style.BottomBorderColor = null;
            this.Style.TextAlignment = TKCalendarCellAlignment.Top;

            if ((this.State & TKCalendarDayState.Selected) != 0)
            {
                this.CurrentImage = gSelectedDayImage;
            }
            else if ((this.State & TKCalendarDayState.Today) != 0)
            {
                this.CurrentImage = gCurrentDayImage;
                this.Label.TextColor = UIColor.White;
            }
            else
            {
                this.CurrentImage = gDayImage;
            }
        }

        public void Initialize()
        {
            gDayImage = UIImage.FromBundle("calendar_cell.png");
            gDayImage = gDayImage.CreateResizableImage(new UIEdgeInsets(4, 4, 4, 4), UIImageResizingMode.Stretch);

            gCurrentDayImage = UIImage.FromBundle("calendar_current_cell.png");
            gCurrentDayImage = gCurrentDayImage.CreateResizableImage(new UIEdgeInsets(4, 4, 4, 4), UIImageResizingMode.Stretch);

            gSelectedDayImage = UIImage.FromBundle("calendar_selected_cell.png");
            gSelectedDayImage = gSelectedDayImage.CreateResizableImage(new UIEdgeInsets(4, 4, 4, 4), UIImageResizingMode.Stretch);
        }

        public override void Draw(CGRect rect)
        {
            this.CurrentImage.Draw(rect);
            base.Draw(rect);
        }
    }
}